/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#ifndef GTKCONFIGVIEW_H
#define GTKCONFIGVIEW_H


#include "configview.h"
#include <gtk/gtk.h>

class ModuleManager;

/**
 * @class GtkConfigView
 * @brief The concrete GTK+ configuration view.
 *
 * This is the main window of sofa-config.  
 */
class GtkConfigView: public ConfigView {
  // Associations
  // Attributes
  private:
    ModuleManager* _modules;
    GtkWidget * _gtkWindow;
    int          _notebookPage;
    GtkWidget * _notebook;
    
    void createNotebook();
    GtkWidget * createModulePage();
    GtkWidget * createThemePage();
    GtkWidget * createKeyboardPage();
    void notebookAddPage(const char *text, GtkWidget *page, int ind);
    GtkTreeRowReference * moduleList(GtkListStore * list);
    
  // Operations
  public:
    GtkConfigView();
    void init ( int argc, char* argv[] );
    void show (  );
    GtkWidget* getWindow (  );
    void setModuleManager(ModuleManager * manager);
};

#endif
