/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "listmenu.h"

ListMenu::ListMenu( ){
}

ListMenu::~ListMenu( ){
}

void ListMenu::doAction (Actions anAction){
  // Since highlight 0 is on top in the screen, going down means ++
  switch(anAction){
    case Menu::MENU: 
      //getParent()->signal_changed = signal_changed; // Transfert the connection
      //signal_changed.clear();
      unselect();
      getParent()->select();
      break;
    case Menu::LEFT: 
      
      break;
    case Menu::UP: 
      if(getHighlightedPos() - 1 >=0 ){
         highlight(getHighlightedPos()-1);
        signal_changed(Menu::HIGHLIGHTED_MENU_CHANGED);
      }
      break;
    case Menu::RIGHT: 
      
      break;
    case Menu::DOWN:
      if(getHighlightedPos() + 1 < size()){
         highlight(getHighlightedPos()+1);
        signal_changed(Menu::HIGHLIGHTED_MENU_CHANGED);
      }
      break;
    case Menu::OK: 
      Menu * m = getHighlighted();
      if(m){
        m->signal_changed = signal_changed; // Transfert the connection
        // The signal will get disconnected from menu::setPercentLoaded()
        m->signal_load();
      }
      break;
  }
}
