/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#include "selectionmenu.h"

#include <assert.h>

SelectionMenu::SelectionMenu()
{
_highlight = 0;
}

void SelectionMenu::add ( Menu * menu ){
  menu->setParent(this);
  _list.push_back(menu);
}

Menu * SelectionMenu::get ( int pos ){
  std::list<Menu*>::const_iterator it;
  int i = 0;
  for(it = _list.begin(); it != _list.end(); ++it){
  
    if (i == pos){
      return *it;
    }
    i++;  
  } 
  return NULL;
  
}

void SelectionMenu::clear (  ){
  assert(!"Unimplemented");
}

int SelectionMenu::size (  ){
  return _list.size();
}

void SelectionMenu::highlight ( int pos ){
  if(pos >=0 && pos < _list.size())
    _highlight = pos;
}

Menu * SelectionMenu::getHighlighted (  ){
  if(_highlight < 0 && _highlight >= _list.size())
    return NULL;
    
  std::list<Menu*>::const_iterator it;
  int i = 0;
  for(it = _list.begin(); it != _list.end(); ++it){
    if (i == _highlight){
      return *it;
    }
    i++;  
  } 
  return NULL;
}

int SelectionMenu::getHighlightedPos (  ){
  return _highlight;
}


