/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "../../sofa-i18n.h"
#include "dummymodule.h"
#include "dummyconfigwindow.h"
#include "assert.h"

DummyModule::DummyModule(){
  _root = NULL;
}

DummyModule::~DummyModule(){

}


const gchar * DummyModule::getName (  ){
  return _("Dummy demo module");
}

const gchar * DummyModule::getSettingName (  ){
  return "dummy";
}

const gchar * DummyModule::getVersion (  ){
  return "0.0.17";
}

const gchar * DummyModule::getAuthor (  ){
  return "Pierre-Luc Beaudoin";
}

const gchar * DummyModule::getDescription (  ){
  return _("This module demonstrates the modular architecture of Sofa");
}

void DummyModule::unload (  ){
  assert(!"Unimplemented");
}

Menu* DummyModule::getMenu (  ){
  if(!_root){
     _root = new ListMenu( );
  
    _root->setTitle(_("Dummy..."));
    _root->setSubtitle(_("Library from dummy world"));
    _root->setImagePath("/usr/share/pixmaps/mozilla-firefox.png");
    _root->signal_load.connect(sigc::mem_fun(this, &DummyModule::loadSubMenu));
  }
  return _root;
}
    
void DummyModule::loadSubMenu(){
  
    SelectionMenu * list = reinterpret_cast<SelectionMenu *>(_root);
    if(list->size()== 0){
      _root->setPercentLoaded(0.1);
      Menu * m = new ListMenu();
      m->setTitle(_("Submenu"));
      m->setSubtitle(_("More text"));
      m->setImagePath("/usr/share/pixmaps/apple-green.png");
      list->add(m);
      
      _root->setPercentLoaded(0.3);
      m = new ListMenu();
      m->setTitle("Submenu2");
      m->setSubtitle("More text");
      m->setImagePath("/usr/share/pixmaps/apple-red.png");
      list->add(m);

      _root->setPercentLoaded(0.6);
      m = new ListMenu();
      m->setTitle("Submenu3");
      m->setSubtitle("More text");
      m->setImagePath("/usr/share/pixmaps/beryl-settings-section-dbus.svg");
      list->add(m);

      _root->setPercentLoaded(0.9);
      m = new ListMenu();
      m->setTitle("Submenu4");
      m->setSubtitle("More text");
      m->setImagePath("/usr/share/pixmaps/mozilla-firefox.png");
      list->add(m);
    }
  
  _root->setPercentLoaded(1.0);
  
}

ConfigWindow * DummyModule::getConfigWindow (  ) {
  DummyConfigWindow * ret = new DummyConfigWindow();
  return ret;
}
