/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
#ifndef RHYTHMBOXMODULE_H
#define RHYTHMBOXMODULE_H

#include "../module.h"
#include "../../menus/selecters/listmenu.h"

#include <string>

class Menu;
class ConfigWindow;
class MusicMenu;

class RhythmboxModule : public Module {
  // Associations
  // Attributes
  // Operations
  private: 
    Menu * _root;
    MusicMenu * _musicMenu;
  public:
    RhythmboxModule();
    const gchar * getName (  );
    const gchar * getSettingName(  );
    const gchar * getVersion (  );
    const gchar * getAuthor (  );
    const gchar * getDescription (  );
    void unload (  );
    Menu* getMenu (  );    
    ConfigWindow * getConfigWindow (  );
    
    void loadSubMenu();
    void loadMusicMenu();
};

#endif 
