/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef CLUTTERMEDIAPLAYER_H
#define CLUTTERMEDIAPLAYER_H

#include "mediaplayer.h"
#include <string>
#include <clutter/clutter-actor.h>


class ClutterMediaPlayer: public MediaPlayer {
  // Associations
  // Attributes
  private:
    ClutterActor * _clutterMedia;
  // Operations
  public:
    void init ( int argc, char* argv[] );
    void play (  );
    void pause (  );
    void setURI ( std::string uri );
    float getProgress (  );
    void setProgress ( float progress );
    float getVolume(  );
    void setVolume ( float percent );
    
    bool isPlaying (  );
    int getDuration (  );
    ClutterActor * getClutterMediaTexture (  );
    
};

#endif
