/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#include "intplaylist.h"
#include "mediaplayer.h"
#include "../clip.h"

void IntPlaylist::init ( int argc, char* argv[], MediaPlayer * mp  ){
  _mediaPlayer = mp;
  _current = 0;
}

void IntPlaylist::append ( Clip* clip ){
  _playlist.push_back(clip);
}

void IntPlaylist::next (  ){
  printf("IntPlaylist::next\n");
  if(_current + 1 < _playlist.size()){
    _current++;
    _mediaPlayer->setURI(getCurrentClip()->getURI());
  } 
  signal_currentChanged.emit();
}

void IntPlaylist::previous (  ){
  printf("IntPlaylist::previous\n");
  if(_current - 1 >= 0){
    _current--;
    _mediaPlayer->setURI(getCurrentClip()->getURI());
    signal_currentChanged.emit();
  }
  
}

void IntPlaylist::clear (  ){
  _playlist.clear();
}

Clip * IntPlaylist::getCurrentClip (  ){
  if(_current >= 0 && _current < _playlist.size()){
    std::list<Clip*>::const_iterator iter;
    int i = 0;

    /** @todo Optimize this search */
    for (iter=_playlist.begin(); iter != _playlist.end(); ++iter){
      if(i == _current){
       return  *iter;
      } 
      i++;
    }
  }
  return NULL;
}

int IntPlaylist::getCurrentPos (  ){
  return _current;
}

int IntPlaylist::size (  ){
  return _playlist.size();
}

