/* 
 * Copyright (C) 2007 Pierre-Luc Beaudoin
 * 
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License 
 * as published by the Free Software Foundation; either 
 * version 2 of the License, or (at your option) any later 
 * version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
 
#ifndef PLAYLIST_H
#define PLAYLIST_H

#include <sigc++/trackable.h>
#include <sigc++/signal.h>

class Clip;
class MediaPlayer;

class Playlist {
  // Associations
  // Attributes
  public:
     sigc::signal<void> signal_currentChanged;
  protected:
    MediaPlayer * _mediaPlayer;
  // Operations
  public:
    virtual void init ( int argc, char* argv[], MediaPlayer * mediaPlayer ) = 0;
    virtual void append ( Clip* clip ) = 0;
    virtual void next (  ) = 0;
    virtual void previous (  ) = 0;
    virtual void clear (  ) = 0;
    virtual Clip * getCurrentClip (  ) = 0;
    virtual int getCurrentPos (  ) = 0;
    virtual int size (  ) = 0;
};

#endif
